Index: palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3610)
+++ palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3611)
@@ -317,328 +217,352 @@
 ! ------------
 !> Matching the chemical species indices. The routine checks what are the indices of the emission input species 
-!  and the corresponding ones of the model species. The routine gives as output a vector containing the number 
-!  of common species: it is important to note that while the model species are distinct, their values could be 
-!  given to a single species in input: for example, in the case of NO2 and NO, values may be passed in input as NOx values.
+!> and the corresponding ones of the model species. The routine gives as output a vector containing the number 
+!> of common species: it is important to note that while the model species are distinct, their values could be 
+!> given to a single species in input: for example, in the case of NO2 and NO, values may be passed in input as
+!> NOx values.
 !------------------------------------------------------------------------------!
-SUBROUTINE chem_emissions_match(emt_att,len_index)   
-
-
-    INTEGER(iwp), INTENT(INOUT)              ::  len_index        !< Variable where to store the number of common species between the input dataset and the model species   
-
-    TYPE(chem_emis_att_type), INTENT(INOUT)  ::  emt_att          !< Chemistry Emission Array containing information for all the input chemical emission species
+SUBROUTINE chem_emissions_match( emt_att,len_index )   
+
+
+    INTEGER(iwp), INTENT(INOUT)             ::  len_index   !< Variable where to store the number of common species between the input dataset and the model species   
+
+    TYPE(chem_emis_att_type), INTENT(INOUT) ::  emt_att     !< Chemistry Emission Array containing information for all the input chemical emission species
    
-    INTEGER(iwp)                             ::  ind_mod, ind_inp !< Parameters for cycling through chemical model and input species 
-    INTEGER(iwp)                             ::  nspec_emis_inp   !< Variable where to store the number of the emission species in input
-
-    INTEGER(iwp)                             ::  ind_voc          !< Indices to check whether a split for voc should be done
-
-    INTEGER(iwp)                             ::  ispec            !> index for cycle over effective number of emission species
-
-
-    !> Tell the user where we are!!
+    INTEGER(iwp) ::  ind_mod, ind_inp                       !< Parameters for cycling through chemical model and input species 
+    INTEGER(iwp) ::  nspec_emis_inp                         !< Variable where to store the number of the emission species in input
+    INTEGER(iwp) ::  ind_voc                                !< Indices to check whether a split for voc should be done
+    INTEGER(iwp) ::  ispec                                  !< index for cycle over effective number of emission species
+
+
     CALL location_message( 'Matching input emissions and model chemistry species', .FALSE. )
 
-    !> Number of input emission species.
-
+    !
+    !-- Number of input emission species.
     nspec_emis_inp=emt_att%nspec 
 
-    !> Check the emission mode: DEFAULT, PRE-PROCESSED or PARAMETERIZED  !TBD: Add option for capital or small letters
-    SELECT CASE(TRIM(mode_emis)) 
-
-       !> PRE-PROCESSED case: in this case the input species have to coincide with the ones of the model (except VOCs for which we have the VOC split): NO and NO2 in input and not NOx.
-       CASE ("PRE-PROCESSED")
-
-          CALL location_message( 'chem_emissions PRE-PROCESSED_mode_matching', .FALSE. )
-
-          len_index=0
-          len_index_voc=0 
-
-          !> The first condition is that both the number of model and input emissions species are not null 
-          IF ( (SIZE(spc_names) .GT. 0) .AND. (nspec_emis_inp .GT. 0)) THEN
-
-             !> Cycle over model species
-             DO ind_mod = 1, SIZE(spc_names)
-                !> Cycle over Input species  
+    !
+    !-- Check the emission mode: DEFAULT, PRE-PROCESSED or PARAMETERIZED 
+    SELECT CASE( TRIM( mode_emis ) ) 
+
+       !
+       !-- PRE-PROCESSED mode
+       CASE ( "PRE-PROCESSED" )
+
+          len_index = 0
+          len_index_voc = 0
+
+          IF ( nvar > 0 .AND. (nspec_emis_inp > 0) )  THEN
+             !
+             !-- Cycle over model species
+             DO ind_mod = 1,  nvar 
+                !
+                !-- Cycle over input species  
                 DO ind_inp = 1, nspec_emis_inp
 
-           !> In the PRE-PROCESSED mode each emission species is given input values, made exception for the VOCs, having the total number of VOCs in input: the model then executes a split through the different VOC species
-                   ! > Check for VOC Species: In input in this case we only have one species (VOC)  
-                   IF (TRIM(emt_att%species_name(ind_inp))=="VOC") THEN
-                      !> Cycle over the input voc species: they have to be one of the VOCs of the mechanism used. A list of VOC species for different mechanisms is provided in the module documentation
-                      DO ind_voc= 1,emt_att%nvoc
-                         !> Determine the indices of the coinciding species in the two cases and assign them to matching arrays 
-                         IF (TRIM(emt_att%voc_name(ind_voc))==TRIM(spc_names(ind_mod))) THEN
-                            len_index=len_index+1
-                            len_index_voc=len_index_voc+1
+                   !
+                   !-- Check for VOC Species  
+                   IF ( TRIM( emt_att%species_name(ind_inp) ) == "VOC" )  THEN        
+                      DO ind_voc = 1, emt_att%nvoc
+             
+                         IF ( TRIM( emt_att%voc_name(ind_voc) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                            len_index = len_index + 1
+                            len_index_voc = len_index_voc + 1
                          ENDIF
                       END DO
                    ENDIF
-                   !> Other Species
-                   IF (TRIM(emt_att%species_name(ind_inp))==TRIM(spc_names(ind_mod))) THEN
-                      len_index=len_index+1
+                   !
+                   !-- Other Species
+                   IF ( TRIM( emt_att%species_name(ind_inp) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                      len_index = len_index + 1
                    ENDIF
                 ENDDO
              ENDDO
 
-             !> Allocate array for storing the indices of the matched species
-             IF (len_index>0) THEN
- 
-                ALLOCATE(match_spec_input(len_index)) 
- 
-                ALLOCATE(match_spec_model(len_index))
-
-                IF (len_index_voc>0) THEN
-
-                   ALLOCATE(match_spec_voc_model(len_index_voc))   !> Contains indices of the VOC model species 
-
-                   ALLOCATE(match_spec_voc_input(len_index_voc))   !> In input there is only one value for VOCs in the DEFAULT mode. This array contains the indices of the different values of VOC compositions of the input variable VOC_composition
+             !
+             !-- Allocate array for storing the indices of the matched species
+             IF ( len_index > 0 )  THEN
+ 
+                ALLOCATE( match_spec_input(len_index) ) 
+ 
+                ALLOCATE( match_spec_model(len_index) )
+
+                IF ( len_index_voc > 0 )  THEN
+                   !
+                   !-- contains indices of the VOC model species
+                   ALLOCATE( match_spec_voc_model(len_index_voc) )
+                   !
+                   !-- contains the indices of different values of VOC composition of input variable VOC_composition
+                   ALLOCATE( match_spec_voc_input(len_index_voc) )
 
                 ENDIF
 
-                !> Repeat the same cycle of above but passing the species indices to the newly declared arrays
-                len_index=0
-
-                !> Cycle over model species
-                DO ind_mod = 1, SIZE(spc_names)  
-                   !> Cycle over Input species  
+                !
+                !-- pass the species indices to declared arrays
+                len_index = 0
+
+                !
+                !-- Cycle over model species
+                DO ind_mod = 1, nvar 
+                   !
+                   !-- Cycle over Input species  
                    DO ind_inp = 1, nspec_emis_inp
-
-                   !> Determine the indices of the coinciding species in the two cases and assign them to matching arrays 
-
-                      ! > VOCs
-                      IF ( TRIM(emt_att%species_name(ind_inp))=="VOC" .AND. ALLOCATED(match_spec_voc_input) ) THEN      
-                         DO ind_voc= 1,emt_att%nvoc
-                            IF (TRIM(emt_att%voc_name(ind_voc))==TRIM(spc_names(ind_mod))) THEN
-                               len_index=len_index+1
-                               len_index_voc=len_index_voc+1
+                      !
+                      !-- VOCs
+                      IF ( TRIM(emt_att%species_name(ind_inp) ) == "VOC" .AND.    &
+                           ALLOCATED(match_spec_voc_input) )  THEN
+                         
+                         DO ind_voc= 1, emt_att%nvoc
+                            IF ( TRIM( emt_att%voc_name(ind_voc) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                               len_index = len_index + 1
+                               len_index_voc = len_index_voc + 1
                         
-                               match_spec_input(len_index)=ind_inp
-                               match_spec_model(len_index)=ind_mod
-
-                               match_spec_voc_input(len_index_voc)=ind_voc
-                               match_spec_voc_model(len_index_voc)=ind_mod                         
+                               match_spec_input(len_index) = ind_inp
+                               match_spec_model(len_index) = ind_mod
+
+                               match_spec_voc_input(len_index_voc) = ind_voc
+                               match_spec_voc_model(len_index_voc) = ind_mod                         
                             ENDIF
                          END DO
                       ENDIF
 
-                      !>Other Species
-                      IF (TRIM(emt_att%species_name(ind_inp))==TRIM(spc_names(ind_mod))) THEN
-                         len_index=len_index+1
-                         match_spec_input(len_index)=ind_inp
-                         match_spec_model(len_index)=ind_mod
+                      !
+                      !-- Other Species
+                      IF ( TRIM( emt_att%species_name(ind_inp) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                         len_index = len_index + 1
+                         match_spec_input(len_index) = ind_inp
+                         match_spec_model(len_index) = ind_mod
                       ENDIF
                    END DO
                 END DO
 
-             !> In the case there are no species matching, the emission module should not be called
              ELSE
-
-                message_string = 'Given Chemistry Emission Species'            //          &
-                                 ' DO NOT MATCH'                                //          &
-                                 ' model chemical species:'                      //          &
-                                 ' Chemistry Emissions routine is not called'  
+                !
+                !-- in case there are no species matching
+                message_string = 'Non of given emission species'            //         &
+                                 ' matches'                                //          &
+                                 ' model chemical species:'                //          &
+                                 ' Emission routine is not called'  
                 CALL message( 'chem_emissions_matching', 'CM0438', 0, 0, 0, 6, 0 )
-             ENDIF !> IF (len_index>0)
+             ENDIF
  
           ELSE
 
-             !In this case either spc_names is null or nspec_emis_inp is not allocated
-
+             !
+             !-- either spc_names is zero or nspec_emis_inp is not allocated
              message_string = 'Array of Emission species not allocated:'             //          &
-                              ' Either no emission species are provided as input or'  //          &
-                              ' no chemical species are used by PALM:'                //          &
-                              ' Chemistry Emissions routine is not called'                  
+                              ' Either no emission species are provided as input or'  //         &
+                              ' no chemical species are used by PALM:'                //         &
+                              ' Emission routine is not called'                  
              CALL message( 'chem_emissions_matching', 'CM0439', 0, 2, 0, 6, 0 ) 
 
-          ENDIF !> IF ( (SIZE(spc_names) .GT. 0) .AND. ALLOCATED(nspec_emis_inp))
-
-       !> ------------------------------------------------------------------
-       !> DEFAULT case
-
+          ENDIF
+
+       !
+       !-- DEFAULT mode
        CASE ("DEFAULT")
 
-          CALL location_message( 'chem_emissions DEFAULT_mode_matching', .FALSE. )
-
-          len_index=0      !>  index for TOTAL number of species   
-          len_index_voc=0  !>  index for TOTAL number of VOCs
-          len_index_pm=3   !>  index for TOTAL number of PM Types: PM1, PM2.5, PM10. It is needed because the number of emission inputs and the one of PMs in the model may not be the same.
-
-          !> The first condition is that both the number of model and input emissions species are not null 
-          IF ( (SIZE(spc_names) .GT. 0) .AND. (nspec_emis_inp .GT. 0) ) THEN
-
-             !> Cycle over model species
-             DO ind_mod = 1, SIZE(spc_names)
-                !> Cycle over input species
+          len_index = 0          !<  index for TOTAL number of species   
+          len_index_voc = 0      !<  index for TOTAL number of VOCs
+          len_index_pm = 3       !<  index for TOTAL number of PMs: PM1, PM2.5, PM10.
+ 
+          IF ( nvar > 0 .AND. nspec_emis_inp > 0 )  THEN
+
+             !
+             !-- Cycle over model species
+             DO ind_mod = 1, nvar
+                !
+                !-- Cycle over input species
                 DO ind_inp = 1, nspec_emis_inp
 
-                   ! > Check for VOC Species: In input in this case we only have one species (VOC)  
-                   IF (TRIM(emt_att%species_name(ind_inp))=="VOC") THEN
-                      !> Cycle over the voc species given in input: they have to be one of the VOCs of the mechanism used. A list of VOC species for different mechanisms is provided in the module documentation 
-                      DO ind_voc= 1,emt_att%nvoc
-                         !> Determine the indices of the coinciding species in the two cases and assign them to matching arrays 
-                         IF (TRIM(emt_att%voc_name(ind_voc))==TRIM(spc_names(ind_mod))) THEN
-                            len_index=len_index+1
-                            len_index_voc=len_index_voc+1
+                   !
+                   !-- Check for VOC Species  
+                   IF ( TRIM( emt_att%species_name(ind_inp) ) == "VOC" )  THEN
+                      DO ind_voc= 1, emt_att%nvoc
+                        
+                         IF ( TRIM( emt_att%voc_name(ind_voc) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                            len_index = len_index + 1
+                            len_index_voc = len_index_voc + 1
                          ENDIF
+                         
                       END DO
                    ENDIF
 
-                   !> PMs: For PMs there is only one input species name for all the PM types. This variable has 3 dimensions, one for each PM type.
-                   IF (TRIM(emt_att%species_name(ind_inp))=="PM") THEN
-                      !>pm1
-                      IF (TRIM(spc_names(ind_mod))=="PM1") THEN
-                         len_index=len_index+1
-                      !>pm2.5
-                      ELSE IF (TRIM(spc_names(ind_mod))=="PM25") THEN
-                         len_index=len_index+1
-                      !>pm10
-                      ELSE IF (TRIM(spc_names(ind_mod))=="PM10") THEN
-                         len_index=len_index+1   
+                   !
+                   !-- PMs: There is one input species name for all PM 
+                   !-- This variable has 3 dimensions, one for PM1, PM2.5 and PM10
+                   IF ( TRIM( emt_att%species_name(ind_inp) ) == "PM" )  THEN
+                      !
+                      !-- PM1
+                      IF ( TRIM( spc_names(ind_mod) ) == "PM1" )  THEN
+                         len_index = len_index + 1
+                      !
+                      !-- PM2.5
+                      ELSEIF ( TRIM( spc_names(ind_mod) ) == "PM25" )  THEN
+                         len_index = len_index + 1
+                      !
+                      !-- PM10
+                      ELSEIF ( TRIM( spc_names(ind_mod) ) == "PM10" )  THEN
+                         len_index = len_index + 1
                       ENDIF
                    ENDIF
 
-                   !> NOx: for NOx by definition we have 2 splits. The Emission Input Name in this case is only one: NOx, while in the model we can have NO2 and NO    
-                   IF (TRIM(emt_att%species_name(ind_inp))=="NOx") THEN 
-                      !>no
-                      IF (TRIM(spc_names(ind_mod))=="NO") THEN
-                         len_index=len_index+1
-                      !>no2
-                      ELSE IF (TRIM(spc_names(ind_mod))=="NO2") THEN
-                         len_index=len_index+1                        
+                   !
+                   !-- NOx: NO2 and NO    
+                   IF ( TRIM( emt_att%species_name(ind_inp) ) == "NOx" )  THEN 
+                      !
+                      !-- NO
+                      IF ( TRIM( spc_names(ind_mod) ) == "NO" )  THEN
+                         len_index = len_index + 1
+                      !
+                      !-- NO2
+                      ELSEIF ( TRIM( spc_names(ind_mod) ) == "NO2" )  THEN
+                         len_index = len_index + 1
                       ENDIF
                    ENDIF
 
-                   !>SOX: same as for NOx, but with SO2 and SO4
-                   IF (TRIM(emt_att%species_name(ind_inp))=="SOx") THEN
-                      !>no
-                      IF (TRIM(spc_names(ind_mod))=="SO2") THEN
-                         len_index=len_index+1
-                      !>no2
-                      ELSE IF (TRIM(spc_names(ind_mod))=="SO4") THEN
-                         len_index=len_index+1                        
+                   !
+                   !-- SOx: SO2 and SO4
+                   IF ( TRIM( emt_att%species_name(ind_inp) ) == "SOx" )  THEN
+                      !
+                      !-- SO2
+                      IF ( TRIM( spc_names(ind_mod) ) == "SO2" )  THEN
+                         len_index = len_index + 1
+                      !
+                      !-- SO4
+                      ELSEIF ( TRIM( spc_names(ind_mod) ) == "SO4" )  THEN
+                         len_index = len_index + 1
                       ENDIF
                    ENDIF
 
-                   !> Other Species
-                   IF (TRIM(emt_att%species_name(ind_inp))==TRIM(spc_names(ind_mod))) THEN
-                      len_index=len_index+1
+                   !
+                   !-- Other Species
+                   IF ( TRIM( emt_att%species_name(ind_inp) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                      len_index = len_index + 1
                    ENDIF
-                END DO   !> number of emission input species
-             END DO   !> number of model species
-
-
-             !> Allocate Arrays
-             IF (len_index>0) THEN
-
-                ALLOCATE(match_spec_input(len_index))
-                ALLOCATE(match_spec_model(len_index))
-
-                IF (len_index_voc>0) THEN
-                   ALLOCATE(match_spec_voc_model(len_index_voc))   !> contains indices of the VOC model species 
-                   ALLOCATE(match_spec_voc_input(len_index_voc))   !> In input there is only one value for VOCs in the DEFAULT mode. 
-                                                                   !  This array contains the indices of the different values of VOC compositions of the input variable VOC_composition
+                END DO
+             END DO
+
+
+             !
+             !-- Allocate arrays
+             IF ( len_index > 0 )  THEN
+
+                ALLOCATE( match_spec_input(len_index) )
+                ALLOCATE( match_spec_model(len_index) )
+
+                IF ( len_index_voc > 0 )  THEN
+                   !
+                   !-- Contains indices of the VOC model species
+                   ALLOCATE( match_spec_voc_model(len_index_voc) )
+                   !
+                   !-- Contains the indices of different values of VOC composition
+                   !-- of input variable VOC_composition
+                   ALLOCATE( match_spec_voc_input(len_index_voc) )                                                  
                 ENDIF
 
-                !> ASSIGN INDICES
-                !> Repeat the same cycles of above, but passing the species indices to the newly declared arrays
-                len_index=0
-                len_index_voc=0
+                !
+                !-- Pass the species indices to declared arrays
+                len_index = 0
+                len_index_voc = 0
                 
-                DO ind_mod = 1, SIZE(spc_names)
+                DO ind_mod = 1, nvar
                    DO ind_inp = 1, nspec_emis_inp 
 
-                      ! > VOCs
-                      IF ( TRIM(emt_att%species_name(ind_inp))=="VOC" .AND. ALLOCATED(match_spec_voc_input) ) THEN      
-                         DO ind_voc= 1,emt_att%nvoc
-                            IF (TRIM(emt_att%voc_name(ind_voc))==TRIM(spc_names(ind_mod))) THEN
-                               len_index=len_index+1
-                               len_index_voc=len_index_voc+1
+                      !
+                      !-- VOCs
+                      IF ( TRIM( emt_att%species_name(ind_inp) ) == "VOC" .AND.   &
+                         ALLOCATED(match_spec_voc_input) )  THEN      
+                         DO ind_voc= 1, emt_att%nvoc
+                            IF ( TRIM( emt_att%voc_name(ind_voc) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                               len_index = len_index + 1
+                               len_index_voc = len_index_voc + 1
                         
-                               match_spec_input(len_index)=ind_inp
-                               match_spec_model(len_index)=ind_mod
-
-                               match_spec_voc_input(len_index_voc)=ind_voc
-                               match_spec_voc_model(len_index_voc)=ind_mod                         
+                               match_spec_input(len_index) = ind_inp
+                               match_spec_model(len_index) = ind_mod
+
+                               match_spec_voc_input(len_index_voc) = ind_voc
+                               match_spec_voc_model(len_index_voc) = ind_mod                         
                             ENDIF
                          END DO
                       ENDIF
 
-                      !> PMs:In this case the Inputs have only PM while the model has three different possible types: PM1, PM2.5, PM10. We need an additional index for matching each PM index in the model. 
-                      IF (TRIM(emt_att%species_name(ind_inp))=="PM") THEN
-                         !>pm1
-                         IF (TRIM(spc_names(ind_mod))=="PM1") THEN
-                            len_index=len_index+1
-
-                            match_spec_input(len_index)=ind_inp
-                            match_spec_model(len_index)=ind_mod
+                      !
+                      !-- PMs 
+                      IF ( TRIM( emt_att%species_name(ind_inp) ) == "PM" )  THEN
+                         !
+                         !-- PM1
+                         IF ( TRIM( spc_names(ind_mod) ) == "PM1" )  THEN
+                            len_index = len_index + 1
+
+                            match_spec_input(len_index) = ind_inp
+                            match_spec_model(len_index) = ind_mod
+                         !
+                         !-- PM2.5
+                         ELSEIF ( TRIM( spc_names(ind_mod) ) == "PM25" )  THEN
+                            len_index = len_index + 1
+
+                            match_spec_input(len_index) = ind_inp
+                            match_spec_model(len_index) = ind_mod
+                         !
+                         !-- PM10
+                         ELSEIF ( TRIM( spc_names(ind_mod) ) == "PM10" )  THEN
+                            len_index = len_index + 1
+    
+                            match_spec_input(len_index) = ind_inp
+                            match_spec_model(len_index) = ind_mod
   
-                            !match_spec_pm(1)=ind_mod
-                         !>pm2.5
-                         ELSE IF (TRIM(spc_names(ind_mod))=="PM25") THEN
-                            len_index=len_index+1
-
-                            match_spec_input(len_index)=ind_inp
-                            match_spec_model(len_index)=ind_mod
-  
-                            !match_spec_pm(2)=ind_mod
-                         !>pm10
-                         ELSE IF (TRIM(spc_names(ind_mod))=="PM10") THEN
-                            len_index=len_index+1
-    
-                            match_spec_input(len_index)=ind_inp
-                            match_spec_model(len_index)=ind_mod
-  
-                            !match_spec_pm(3)=ind_mod
                          ENDIF
                       ENDIF
 
-                      !> NOx - The same as for PMs but here the model species are only 2: NO and NO2
-                      IF (TRIM(emt_att%species_name(ind_inp))=="NOx") THEN
-                         !>no
-                         IF (TRIM(spc_names(ind_mod))=="NO") THEN
-                            len_index=len_index+1
-
-                            match_spec_input(len_index)=ind_inp
-                            match_spec_model(len_index)=ind_mod
+                      !
+                      !-- NOx 
+                      IF ( TRIM( emt_att%species_name(ind_inp) ) == "NOx" )  THEN
+                         !
+                         !-- NO
+                         IF ( TRIM( spc_names(ind_mod) ) == "NO" )  THEN
+                            len_index = len_index + 1
+
+                            match_spec_input(len_index) = ind_inp
+                            match_spec_model(len_index) = ind_mod
+                         !
+                         !-- NO2
+                         ELSEIF ( TRIM( spc_names(ind_mod) ) == "NO2" )  THEN
+                            len_index = len_index + 1
+
+                            match_spec_input(len_index) = ind_inp
+                            match_spec_model(len_index) = ind_mod
   
-                            !match_spec_nox(1)=ind_mod
-                         !>no2
-                         ELSE IF (TRIM(spc_names(ind_mod))=="NO2") THEN
-                            len_index=len_index+1
-
-                            match_spec_input(len_index)=ind_inp
-                            match_spec_model(len_index)=ind_mod
-  
-                           ! match_spec_nox(2)=ind_mod
                          ENDIF
                       ENDIF
 
-                      !> SOx 
-                      IF (TRIM(emt_att%species_name(ind_inp))=="SOx") THEN
-                         !>so2
-                         IF (TRIM(spc_names(ind_mod))=="SO2") THEN
-                            len_index=len_index+1
-
-                            match_spec_input(len_index)=ind_inp
-                            match_spec_model(len_index)=ind_mod
+                      !
+                      !-- SOx 
+                      IF ( TRIM( emt_att%species_name(ind_inp) ) == "SOx" ) THEN
+                         !
+                         !-- SO2
+                         IF ( TRIM( spc_names(ind_mod) ) == "SO2" )  THEN
+                            len_index = len_index + 1
+
+                            match_spec_input(len_index) = ind_inp
+                            match_spec_model(len_index) = ind_mod
   
-                           ! match_spec_sox(1)=ind_mod
-                         !>so4
-                         ELSE IF (TRIM(spc_names(ind_mod))=="SO4") THEN
-                            len_index=len_index+1
-
-                            match_spec_input(len_index)=ind_inp
-                            match_spec_model(len_index)=ind_mod
+                         !
+                         !-- SO4
+                         ELSEIF ( TRIM( spc_names(ind_mod) ) == "SO4" )  THEN
+                            len_index = len_index + 1
+
+                            match_spec_input(len_index) = ind_inp
+                            match_spec_model(len_index) = ind_mod
   
-                           ! match_spec_sox(2)=ind_mod
                          ENDIF
                       ENDIF
 
-                      !> Other Species
-                      IF (TRIM(emt_att%species_name(ind_inp))==TRIM(spc_names(ind_mod))) THEN
-                         len_index=len_index+1
+                      !
+                      !-- Other Species
+                      IF ( TRIM( emt_att%species_name(ind_inp) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                         len_index = len_index + 1
                             
-                         match_spec_input(len_index)=ind_inp
-                         match_spec_model(len_index)=ind_mod
+                         match_spec_input(len_index) = ind_inp
+                         match_spec_model(len_index) = ind_mod
                       ENDIF
                    END DO
@@ -647,8 +571,8 @@
              ELSE
 
-                message_string = 'Given Chemistry Emission Species'            //          &
-                                 ' DO NOT MATCH'                                //          &
-                                 ' model chemical species'                      //          &
-                                 ' Chemistry Emissions routine is not called'         
+                message_string = 'Non of given Emission Species'            //         &
+                                 ' matches'                                //          &
+                                 ' model chemical species'                 //          &
+                                 ' Emission routine is not called'         
                 CALL message( 'chem_emissions_matching', 'CM0440', 0, 0, 0, 6, 0 ) 
 
